<?php
  //
  // Copyright Dipl.-Ing. Uwe Klatt 2008-2013
  //
  include 'lang.inc';
  include 'helper.inc';
  $ini = parse_ini_file("setup/settings.inc",FALSE);

  $aktday = $_GET['date'];
  $tag = intval(substr($aktday,6,2));
  $mon = intval(substr($aktday,4,2));
  $jahr = intval(substr($aktday,0,4));
  $vortag = date("Ymd", mktime(0, 0, 0, $mon, ($tag-1), $jahr));

  // Output the headers to download the file
  header("Content-type: text/comma-separated-values");
  header("Content-Disposition: attachment; filename=".$aktday.".csv");
  header("Pragma: no-cache");
  header("Expires: 0");

  echo $_['Uhrzeit'][$l];
  for($w=0; $w<$nwr; $w++) // Alle WR + Zhler
  {
    if($w<$nwr && strlen($ini['wr'.($w+1).'_sn']) < 3)
      continue;
    echo "\t".$_['WR'][$l].($w+1)."(Wh)\tPac(W)\tPdc1(W)\tUdc1(V)\tIdc1(mA)\tPdc2(W)\tUdc2(V)\tIdc2(mA)\tPdc3(W)\tUdc3(V)\tIdc3(mA)";
  }
  echo "\tBezug(Wh)\tLieferung(Wh)";
  echo "\n\r";

  for($w=0; $w<=$nwr; $w++) // Alle WR + Zhler
  {
    if($w<$nwr && strlen($ini['wr'.($w+1).'_sn']) < 3)
      continue;

    if($w<$nwr) // WR
    {
      $receive = logger("GETDAY;".$aktday.";".$w.";0;E-Total"); // Ertrag
      $daten = explode(";",$receive);
      $receive = logger("GETDAY;".$aktday.";".$w.";0;Pac"); // Pac
      $pac[$w] = explode(";",$receive);
      $receive = logger("GETDAY;".$aktday.";".$w.";0;PPV"); // Pdc 1
      $pdc1[$w] = explode(";",$receive);
      $receive = logger("GETDAY;".$aktday.";".$w.";0;Upv-Ist"); // Udc 1
      $udc1[$w] = explode(";",$receive);
      $receive = logger("GETDAY;".$aktday.";".$w.";0;Ipv"); // Idc 1
      $idc1[$w] = explode(";",$receive);
      $receive = logger("GETDAY;".$aktday.";".$w.";1;PPV"); // Pdc 2
      $pdc2[$w] = explode(";",$receive);
      $receive = logger("GETDAY;".$aktday.";".$w.";1;Upv-Ist"); // Udc 2
      $udc2[$w] = explode(";",$receive);
      $receive = logger("GETDAY;".$aktday.";".$w.";1;Ipv"); // Idc 2
      $idc2[$w] = explode(";",$receive);
      $receive = logger("GETDAY;".$aktday.";".$w.";2;PPV"); // Pdc 3
      $pdc3[$w] = explode(";",$receive);
      $receive = logger("GETDAY;".$aktday.";".$w.";2;Upv-Ist"); // Udc 3
      $udc3[$w] = explode(";",$receive);
      $receive = logger("GETDAY;".$aktday.";".$w.";2;Ipv"); // Idc 3
      $idc3[$w] = explode(";",$receive);
    }
    else // Zhler
    {
      $receive = logger("GETDAY;".$vortag.";".$nwr.";0;Eplus"); // Bezug
      $datenp0 = explode(";",$receive);
      $receive = logger("GETDAY;".$aktday.";".$nwr.";0;Eplus"); // Bezug
      $datenp = explode(";",$receive);
      $receive = logger("GETDAY;".$vortag.";".$nwr.";0;Eminus"); // Lieferung
      $datenm0 = explode(";",$receive);
      $receive = logger("GETDAY;".$aktday.";".$nwr.";0;Eminus"); // Lieferung
      $datenm = explode(";",$receive);
    }

    $ertragsum = 0;
    for($i=0; $i<144; $i++) // Alle 10 Min
    {
      if($w<$nwr) // WR
      {
        if($i==0)
          $v = 0;
        else if(($daten[$i]>0) && ($daten[$i-1]>0))
        {
          $v = ($daten[$i]-$daten[$i-1])*$ini['pv_mul'];
          if(($v < 0) || ($v > 100000))
            $v = 0;
        }
        else
          $v = 0;
        $ertragsum += $v;
        $ertrag[$w][$i] = $v;
      }
      else // Zhler
      {
        if($i==0)
        {
          if(($datenp[$i]>0) && ($datenp0[143]>0))
            $v = ($datenp[$i]-$datenp0[143]);
          else
            $v = 0;
        }
        else if(($datenp[$i]>0) && ($datenp[$i-1]>0))
          $v = ($datenp[$i]-$datenp[$i-1]);
        else
          $v = 0;
        $ertragp[$w][$i] = $v;

        if($i==0)
        {
          if(($datenm[$i]>0) && ($datenm0[143]>0))
            $v = ($datenm[$i]-$datenm0[143]);
          else
            $v = 0;
        }
        else if(($datenm[$i]>0) && ($datenm[$i-1]>0))
          $v = ($datenm[$i]-$datenm[$i-1]);
        else
          $v = 0;
        $ertragm[$w][$i] = $v;
      }
    }
  }

  // Ausgabe der Werte
  for($i=0; $i<144; $i++) // Alle 10 Min
  {
    echo sprintf("%02d:%02d",($i+1)/6,(($i+1)%6)*10);
    for($w=0; $w<=$nwr; $w++)
    {
      if($w<$nwr && strlen($ini['wr'.($w+1).'_sn']) < 3)
        continue;
      if($w<$nwr) // WR
      {
        if($i>24 && $i<136)
        {
          echo sprintf("\t%d",$ertrag[$w][$i]);
          echo sprintf("\t%d",$pac[$w][$i]);
          echo sprintf("\t%d",$pdc1[$w][$i]);
          echo sprintf("\t%d",$udc1[$w][$i]);
          echo sprintf("\t%d",$idc1[$w][$i]);
          echo sprintf("\t%d",$pdc2[$w][$i]);
          echo sprintf("\t%d",$udc2[$w][$i]);
          echo sprintf("\t%d",$idc2[$w][$i]);
          echo sprintf("\t%d",$pdc3[$w][$i]);
          echo sprintf("\t%d",$udc3[$w][$i]);
          echo sprintf("\t%d",$idc3[$w][$i]);
        }
        else
          echo "\t0\t0\t0\t0\t0\t0\t0\t0\t0\t0\t0";
      }
      else // Zhler
      {
        echo sprintf("\t%d",$ertragp[$w][$i]);
        echo sprintf("\t%d",$ertragm[$w][$i]);
      }
    }
    echo "\r\n";
  }
?>

